package monitor;
/**
 * Classe Cond.
 */
public class Cond {
    Monitor mon;
    int condCount;

    /**
     * Costruttore della classe Cond.
     *
     * @param mon monitor globale
     */

    public Cond(Monitor mon){

	this.mon = mon;
    }

    /**
     * Procedura Wait.
     *
     * Gestisce la sospensione dei processi rilasciando prima il monitor.
     */
    synchronized public void Wait() {
	condCount ++;
	if (mon.urgentCount > 0)
	    {
		mon.urgentQueue.Signal();
	    }
	else
	    {
		mon.mutex.Signal();
	    }
	try{
	    wait();
	} catch(InterruptedException e){}
	Thread.currentThread().yield();
	condCount --;
    }

    /**
     * Procedura SignalNascosta.
     *
     * Gestisce le Signal in modo da renderla bloccante.
     */
    synchronized private boolean SignalNascosta() {
	if (condCount > 0) {
	    mon.urgentCount++;
	    notify();
	    return true;
	} else
	    return false;

    }

    /**
     * Procedura Signal.
     *
     * Gestisce la Signal risvegliando un processo sospeso(quando ve ne sono)
     * e bloccando il processo sulla coda delle Urgent, sempre che vi fossero processi sospesi.
     *
     */
    public void Signal() {
	if (SignalNascosta())
	    {
		mon.urgentQueue.Wait();
	    }
    }

    /**
     * Procedura Queue.
     *
     * Verifica l'esistenza di processi sospesi.
     */
    synchronized public boolean queue() {
	if (condCount > 0) return true;
	else return false;
    }

}
