package monitor;
/**
 * Classe Monitor per la gestione dei monitor.
 */
public abstract class Monitor {

    Mutex mutex = new Mutex();
    Urgent urgentQueue = new Urgent(this);
    int urgentCount = 0;

    /**
     * Costruttore della classe Monitor
     */
    public Monitor() {
    }

    /**
     * Procedura entraMonitor,
     * gestisce le entrate nel monitor.
     */
    public void entraMonitor() {
	mutex.Wait();
    }

    /**
     * Procedura esciMonitor,
     * gestisce la procedura di uscita dai monitor.
     */
    public void esciMonitor() {
	if (urgentCount > 0)
	    {
		urgentQueue.Signal();
	    }
	else
	    {
		mutex.Signal();
	    }
    }
}

