package monitor;
/**
 *  Classe Mutex.
 */
public class Mutex {
    private boolean occupato = false;

    /**
     * Provedura Wait
     *
     *  Gestisce la sospensione dei processi.
     */
    synchronized public void Wait() {
	while (occupato)
	    try{
		wait();
	    } catch(InterruptedException e){}
	occupato = true;
    }

    /**
     * Procedura Signal.
     *
     * Gestisce  il risveglio dei processi sospesi.
     */
    synchronized public void Signal() {
	occupato = false;
	notify();
    }

}
