package monitor;
/**
 *  Classe Urgent.
 **/
public class Urgent {
    private int n_sig = 0;
    private Monitor mon;

    /**
     * Costruttore della classe Urgent.
     *
     * @param mon monitor globale
     */
    public Urgent(Monitor mon)
    {
	this.mon = mon;
    }

    /**
     * Procedura Wait.
     *
     * Gestisce la sospensione dei processi nella coda degli Urgent.
     */
    synchronized public void Wait() {
	if (n_sig == 0)
	    try{
		wait();
	    } catch(InterruptedException e){}
	n_sig--;
	mon.urgentCount--;
    }

    /**
     * Procedura Signal.
     *
     * Gestisce  il risveglio dei processi sospesi sulla coda degli Urgent.
     */
    synchronized public void Signal() {
	notify();
	n_sig++;
    }

}
