package monitor;
/**
 * Classe principale che gestisce tutte le variabili condivise
 *
 * <p>Title: Progetto di Sistemi 2, Ascensori con i Monitor</p>
 * <p>Description: Implementazione di un palazzo con due risorse ascensori, ai quali le persone accedono in concorrenza.</p>
 * <p>Company: </p>
 * @author Alessandro Boschi, Andrea Fabrizi, Alessandro Ronchi, Angelo Scozzoli
 * @version 1.0
 */

public class monitor_ascensori extends Monitor
    {
    /**Cond per le code in entrata su i piani [direzone(3 su 1 giu)][piano]*/
    public Cond codain[][]=new Cond[4][10];
    /**numero persone in entrata su i oiani [direzopne(3 su 1 giu)][piano]*/
    public int intcodain[][]=new int[4][10];
    /**Cond per le code in uscita dall'ascensore[ascensore][piano]*/
    public Cond codaout[][]=new Cond[2][10];
    /**numero persone in uscita dall'ascensore [ascensore][piano]*/
    public int intcodaout[][]=new int[2][10];
    /**contatore degli ascensori fermi*/
    public int ascensori_fermi;
    /**Cond la gestione degli ascensori quando non vi sono pi persone*/
    public Cond ascensore;

    public boolean disegna[]=new boolean[2];//boolean per disegnare il movimento dell'ascensore
    public boolean disegnapersona[]=new boolean[2];
    public boolean attesa[]=new boolean[2];//grafica delle persone
    /**dizezione degli ascensori 1 giu 3 su*/
    public int direzioneasc[]=new int[2];
    /**numero posti liberi negli ascensori*/
    public int postiascensore[]=new int[2];
    /**piano corrente degli ascensori*/
    public int pianoascensore[]=new int[2];
    public boolean statusascensore[]=new boolean[2];//stato ascensore(possibilit o no di salire)
    private int i;
    public final int direct_su = 3;
    public final int direct_giu = 1;
    public int npiani;//numero piani globali
    public int ultimo[]=new int[2];


    /**
     * Costruttore della classe principale.
     * Di questa classe deve essere istanziato un solo oggetto che poi verr passato
     * alle altre classi.
     * Inizializza tutte le varidili cond e azzera i rispettivi indici.
     * @param nascensori numero di ascensori
     * @param np numero di piani
     */
    public monitor_ascensori(int np, int nascensori)
    {
	int h;
	direzioneasc[0]=direct_su;
	direzioneasc[1]=direct_su;
	this.npiani=np;
	ascensori_fermi=0;
	ascensore = new Cond(this);
	disegna[0]=false;
	disegna[1]=false;
	disegnapersona[0]=true;
	disegnapersona[1]=true;
	ultimo[0]=0;
	ultimo[1]=0;

	attesa[0]=true;
	attesa[1]=true;
	for (i=0; i <= (npiani-1); i++)
	    {
		codain[direct_su][i] = new Cond(this);//inizializzazione code
		codain[direct_giu][i] = new Cond(this);//inizializzazione code
		intcodain[direct_su][i] = 0;
		intcodain[direct_giu][i] = 0;
		for (h=0; h <= (nascensori-1); h++)
		    {
			codaout[h][i] = new Cond(this);
			intcodaout[h][i] = 0;
		    }
	    }
	for (i=0 ; i!=(nascensori); i++)
	    {
		postiascensore[i]=5;
		pianoascensore[i]=0;
		statusascensore[i]=false;
	    }
    }
    /**
     * Funzioni usate dalla classe persona.
     *
     */

    /**
     * Procedura che gestisce l'inserimento dell'utente nelle cone.
     * La persona viene creata, sveglia gli ascensori fermi(se ve ne sono),
     * si mette in coda sul suo piano di partenza e nella sua direzione.
     * Quando viene svegliato cerca l'ascensore che lo ha rimosso dalla coda e vi sale
     * mettendosi nella coda per la propria destinazione, verr in fine risvegliato per scendere.
     * @param pers parametri dell'utente che deve essere gestito.
     */
    public void iniziapers(persona pers)
    {
	entraMonitor();
	for (i=0; i< ascensori_fermi; ascensori_fermi--)  //mutuaesclusione
	    {
		ascensore.Signal();
	    }
	intcodain[pers.direzione][pers.piano_from]++;//coda incrementata
	codain[pers.direzione][pers.piano_from].Wait();//la persona si mette in coda nel piano di partenza e nella
	// direzione in cui vuole andare
	intcodain[pers.direzione][pers.piano_from]--;//coda decrementata
	while ((pianoascensore[pers.id_asc]!=pers.piano_from) || !(statusascensore[pers.id_asc])|| (pers.direzione!=direzioneasc[pers.id_asc]))
	    pers.id_asc++;//cerca l'asensore ch fermo al piano a cui deve salire, ceh  aperto e che va nella stessa direzione
	pers.imagefile=("pass"+pers.gif+"_"+pers.id_asc+".gif");
	pers.muove=true;
	ultimo[pers.id_asc]++;
	postiascensore[pers.id_asc]--;
	if (postiascensore[pers.id_asc]>0)//se vi sono ancora posti sveglia le eventuali persone della stessa coda
	    {
		codain[pers.direzione][pers.piano_from].Signal();
	    }
	if ((postiascensore[pers.id_asc]>0)||(intcodain[pers.direzione][pers.piano_from]>0))
	    statusascensore[pers.id_asc]=false;
        esciMonitor();
	while(pers.muove)
	    {
		try
		    { Thread.sleep(100);
		    }
                     catch (Exception e){}
	    }
        entraMonitor();
        ultimo[pers.id_asc]--;
        if (ultimo[pers.id_asc]==0)
	    {
		disegnapersona[pers.id_asc]=false;
            }
	intcodaout[pers.id_asc][pers.piano_to]++;//incremento numero persone in coda per scendere
	codaout[pers.id_asc][pers.piano_to].Wait();
	intcodaout[pers.id_asc][pers.piano_to]--;//decremento numero persone in coda per scendere
	esciMonitor();
    }
    /**
     * Funzioni usate dalla classe Ascensore.
     *
     */

    /**
     * Procedura che gestisce la partenza dell'ascensore e la ricerca delle eventuali persone in attesa.
     * L'ascensore parte e si blocca, se viene risvegliato dall'arrivo di una persona
     * fa una scansione partendo dal piano pi distante prima nella sua direzione,
     * poi nella direzione opposta. Se non trova nessuno allora si mette
     * in pausa, altrimenti chiama la procedura di movimento passandogli il piano di destinazione.
     * Il procedimento di blocco viene regolato tramite la variabile "cambio_dir"
     * che memorizza quante volte l'ascensore ha cambiato la propria direzione.
     * @param asc parametri dell'ascensore che deve essere gestito.
     */

    public void asc_go(Ascensore asc)
    {
	entraMonitor();
	if (asc.cambio_dir==2)
	    {
		if ((intcodain[direct_su][asc.piano_tmp]!=0)||(intcodain[direct_giu][asc.piano_tmp]!=0))
		    {//prima di bloccarsi guarda se vi  qualcuno sullo stesso piano e in direzione pposta alla sua
			esciMonitor();
			direzioneasc[asc.id]=(4-direzioneasc[asc.id]);//inverte la direzione dell'ascensore
			muovi(asc.piano_tmp,asc.id);//sposta l'ascensore fino al piano di destinazione facendo entrare le persone che trova sul suo percorso
			asc.cambio_dir=0;
			entraMonitor();
		    }
		else
		    {
			ascensori_fermi++;
			ascensore.Wait();//si ferma perch non vi sono pi persone
			asc.cambio_dir=0;
		    }
	    }
	else
	    {
		if (direzioneasc[asc.id] == direct_su)
		    {
			asc.piano_tmp=(npiani-1);
			//ciclo di ricerca del piano di destinazione, parte dal piano pi lontamo, ma nella sua direzione e
			//cerca se vi  qualcuno che vuole andare in una qualsiasi direzione. Questo per il movimento a spazzola.
			while(((asc.piano_tmp!=(pianoascensore[asc.id]))&&
			       (intcodain[direct_su][asc.piano_tmp]==0)&&
			       (intcodain[direct_giu][asc.piano_tmp]==0)&&
			       (intcodaout[asc.id][asc.piano_tmp]==0)))
			    asc.piano_tmp--;
			if (asc.piano_tmp != (pianoascensore[asc.id]))//se ha trovato qualcuno si mouve
			    {
				esciMonitor();
				muovi(asc.piano_tmp,asc.id);
				asc.cambio_dir=0;
				entraMonitor();
			    }
			else//se non ha trovato nessuno cambia direzione
			    {
				asc.cambio_dir++;
				direzioneasc[asc.id]=direct_giu;
			    }
		    }
		else
		    {
			asc.piano_tmp=0;
			//ciclo di ricerca del piano di destinazione, parte dal piano pi lontamo, ma nella sua direzione e
			//cerca se vi  qualcuno che vuole andare in una qualsiasi direzione. Questo per il movimento a spazzola.
			while((asc.piano_tmp!=(pianoascensore[asc.id]))&&
			      (intcodain[direct_su][asc.piano_tmp]==0)&&
			      (intcodain[direct_giu][asc.piano_tmp]==0)&&
			      (intcodaout[asc.id][asc.piano_tmp]==0))
			    asc.piano_tmp++;
			if (asc.piano_tmp != (pianoascensore[asc.id]))//se ha trovato qualcuno si mouve
			    {
				esciMonitor();
				muovi(asc.piano_tmp,asc.id);
				asc.cambio_dir=0;
				entraMonitor();
			    }
			else//se non ha trovato nessuno cambia direzione
			    {
				asc.cambio_dir++;
				direzioneasc[asc.id]=direct_su;
			    }
		    }
	    }//end else
	esciMonitor();
    }
    /**
     * Procedura che gestisce il movimento dell'ascensore.
     * Se questa procedura  attivata vuol dire che vi  qualcuno che aspetta l'ascensore,
     * quindi l'ascensore si muove verso la sua chiamata pi lontana fermandosi a caricare chiunque
     * voglia andare nella stessa direzione a patto che vi siano posti liberi.
     * Naturalmente facendo prima scendere chi  arrivato a destinazione.
     *
     * @param asc_id identificatore dell'ascensore che deve essere gestito.
     * @param piano_dest piano verso qui l'ascensore si deve muovere.
     */

    public void muovi(int piano_dest, int asc_id)
    {
	entraMonitor();
	//controllo che la chiamata sia ancora valida, altrimenti torna a cercarne un'altra
	while((piano_dest!=(pianoascensore[asc_id]))&&
	      ((intcodain[direct_su][piano_dest]!=0)||
	       (intcodain[direct_giu][piano_dest]!=0)||
	       (intcodaout[asc_id][piano_dest]!=0)))
	    {
		//l'ascensore si rende disponibile a fare salire e scendere le persone
		//se vi  qualcuno che  arrivato al piano richieto lo fa scendere
		for (i=intcodaout[asc_id][pianoascensore[asc_id]];i!=0;i--)
		    {
			codaout[asc_id][pianoascensore[asc_id]].Signal();//sveglia le persone che sono arrivate a destinazione
			postiascensore[asc_id]++;//aggiunge 1 ai posti liberi
      		    }
		//fa salire chi va nella sua direzione
		while ((intcodain[direzioneasc[asc_id]][pianoascensore[asc_id]]!=0)&&
		    (postiascensore[asc_id]!=0))
		    {
			while ((pianoascensore[1-asc_id]==pianoascensore[asc_id])&&
			       (direzioneasc[1-asc_id]==direzioneasc[asc_id])&&
			       (statusascensore[1-asc_id]))
			    {//serve per rendere meglio l'effetto grafico
				esciMonitor();
				try
				    { Thread.sleep(100);
				    }
				catch (Exception e){}
				entraMonitor();
			    }statusascensore[asc_id]=true;

                        attesa[asc_id]=true;
			codain[direzioneasc[asc_id]][pianoascensore[asc_id]].Signal();//sveglia chi deve salire
			esciMonitor();
			while(disegnapersona[asc_id])
			    {//serve per rendere meglio l'effetto grafico
				try
				    { Thread.sleep(100);
				    }
				catch (Exception e){}
			    }
			entraMonitor();
			disegnapersona[asc_id]=true;

		    }
		statusascensore[asc_id]=false;//blocca nell'ascensore la disponibilit di fare salire e scendere le persone
		if (piano_dest!=pianoascensore[asc_id])
		    {// si sposta di un piano se non  arrivato a destinazione
			pianoascensore[asc_id] = (pianoascensore[asc_id]+(direzioneasc[asc_id] -2));
			esciMonitor();//serve per rendere meglio l'effetto grafico
			try
			    {
				while(!disegna[asc_id])
				    {
					try
					    { Thread.sleep(20);
					    }
					catch (Exception e){}
				    }
				disegna[asc_id]=false;
			    }
			catch (Exception e){}
			entraMonitor();
		    }
	    }//quando l'ascensore  arrivato a destianzione o non vi sono pi cheamate da o per il piano di destianzione
	//l'ascensore si rende disponibile a fare salire e scendere le persone
	for (i=intcodaout[asc_id][pianoascensore[asc_id]];i!=0;i--)
	    {//fa scendere le persone
		codaout[asc_id][pianoascensore[asc_id]].Signal();
		postiascensore[asc_id]++;
	    }

	while ((intcodain[direzioneasc[asc_id]][pianoascensore[asc_id]]!=0)&&
	    (postiascensore[asc_id]!=0))
	    {//fa salire le persone
                while ((pianoascensore[1-asc_id]==pianoascensore[asc_id])&&
		       (direzioneasc[1-asc_id]==direzioneasc[asc_id])&&
		       (statusascensore[1-asc_id]))
		    {//serve per rendere meglio l'effetto grafico
			esciMonitor();
			try
			    { Thread.sleep(100);
			    }
			catch (Exception e){}
			entraMonitor();
		    }
		statusascensore[asc_id]=true;
                attesa[asc_id]=true;
		codain[direzioneasc[asc_id]][pianoascensore[asc_id]].Signal();
		esciMonitor();
		while(disegnapersona[asc_id])
		    {//serve per rendere meglio l'effetto grafico
			try
			    { Thread.sleep(100);
			    }
			catch (Exception e){}
		    }
		entraMonitor();
		disegnapersona[asc_id]=true;

	    }

	statusascensore[asc_id]=false;//blocca nell'ascensore la disponibilit di fare salire e scendere le persone
	esciMonitor();
    }
}
